﻿/**************************************************************************************************************************************************
*  Script : BT_inside_MZ "Affichage des informations des Systèmes Tactiques des Bricol'Trolls sur la page de Vue de MountyHall"                   *
*  Compatibilité : encodage UTF-8 (Greasemonkey)                                                                                                  *
*  Pré-requis : nécessite l'utilisation du script BT_inside_MZ.js dans MoutyZilla (ou des scripts Tout_MZ.user.js et BT_inside_Tout_MZ.user.js)   *
*  Auteur : Vapulabehemot (82169)                                                                                                                 *
*  Version : 1.1.3 (27/10/2018) adaptation à Firefox 63.0 et/ou ViolentMonkey 2.9.9                                                               *
*  Historique : 1.1.2 (29/07/2017) adaptation au changement de l'ordre des colonnes de la zone Trolls dans la page de Vue MH                      *
*               1.1.1 (21/08/2015) adaptation à la nouvelle structure de la page de Vue MH                                                        *
*               1.1.0 (12/07/2013) gestion de multiples Systèmes Tactiques                                                                        *
*               1.0.0 (07/07/2013) gestion des Suivants du Système Tactique                                                                       *
*               0.1.0 (29/06/2013) gestion des Trolls du Système Tactique                                                                         *
*               0.0.1 (08/06/2013)                                                                                                                *
**************************************************************************************************************************************************/


// ==UserScript==
// @name         MH - Vapulabehemot - BT_inside_MZ
// @namespace    MH
// @description  Affichage des informations des Systèmes Tactiques des Bricol'Trolls sur la page de Vue de MountyHall, version 1.1.3 du 27/10/2018, par Vapulabehemot (82169)
// @include      */trolls.ratibus.net/*/index.php*
// @include      */trolls.ratibus.net/*/gowaps_tanieres.php*
// @include      */mountyhall/MH_Play/Play_vue.php*
// @exclude      *smartphone*
// @icon         http://mz.mh.raistlin.fr/mz/img/mz_logo_small.png
// @version      1.1.3
// @grant        GM_getValue
// @grant        GM_setValue
// @injectframes 1
// ==/UserScript==


// *** PARAMETRAGE ***
var dureeAffichageInfo = 72; // 72 heures = 72
var dureeInfoTrollsRecentes = 1; // 1 heure = 1
var dureeInfoTrollsAnciennes = 4; // 4 heures = 4
var dureeInfoTrollsPerimees = 24; // 24 heures = 24
var dureeInfoSuivantsRecentes = 6; // 6 heures = 6
var dureeInfoSuivantsAnciennes = 24; // 12 heures = 24
var dureeInfoSuivantsPerimees = 48; // 48 heures = 48
var urlIconeAffichageInfo = 'http://games.mountyhall.com/MH_Packs/packMH_parchemin/bullet/bullet_purple.jpg'; // puce grise MountyHall 'http://games.mountyhall.com/MH_Packs/packMH_parchemin/bullet/bullet_purple.jpg'
var urlIconeInfoRecentes = 'http://games.mountyhall.com/MH_Packs/packMH_parchemin/bullet/bullet_green.jpg'; // puce verte MountyHall 'http://games.mountyhall.com/MH_Packs/packMH_parchemin/bullet/bullet_green.jpg'
var urlIconeInfoAnciennes = 'http://games.mountyhall.com/MH_Packs/packMH_parchemin/bullet/bullet_orange.jpg'; // puce orange MountyHall 'http://games.mountyhall.com/MH_Packs/packMH_parchemin/bullet/bullet_orange.jpg'
var urlIconeInfoPerimees = 'http://games.mountyhall.com/MH_Packs/packMH_parchemin/bullet/bullet_red.jpg'; // puce rouge MountyHall 'http://games.mountyhall.com/MH_Packs/packMH_parchemin/bullet/bullet_red.jpg'
var urlIconeVisibilite = 'http://trolls.ratibus.net/images/warning.gif'; // image "visibilité" du site des Bricol'Trolls 'http://trolls.ratibus.net/images/warning.gif'
var couleurJouable = '#336633'; // vert '#336633'
var couleurNonJouable = '#990000'; // rouge '#990000'
var couleurLigneTrolls = '#BBBBFF'; // bleu-violet '#BBBBFF'
var couleurLigneTrollsHorsVue = '#D5BC3C'; // ocre '#D5BC3C'
var couleurLigneSuivantsPerso = '#AAFFAA'; // vert-clair '#AAFFAA'
var couleurLigneSuivants = '#BBBBFF'; // bleu-violet '#BBBBFF'

// *** CONSTANTES GLOBALES ***
var distanceMax = 9999; // distance des Trolls dont les informations sont périmées (doit être 9999 au maximum)
		

// *** VARIABLES GLOBALES ***
var trollsDesST = new Array;
  

// *** Procédure principale exécutée sur la page d'accueil du site des Bricol'Trolls ***
if ( window.self.location.toString().indexOf('/index.php') != -1 && document.getElementById('trollsList') != null ) {
	try {
		// récupération des informations des Systèmes Tactiques
		var systemeTactique = window.self.location.toString().substr(0, window.self.location.toString().indexOf('/index.php')).replace('http://trolls.ratibus.net/', '');
		var listeGroupes = document.getElementById('id_g');
		var nomGroupe = listeGroupes.options[listeGroupes.selectedIndex].text;
		var referenceGroupe = listeGroupes.options[listeGroupes.selectedIndex].value;
		var listeTrolls = document.getElementById('trollsList').getElementsByTagName('tr');
		
		// récupération des informations de chaque Troll des Systèmes Tactiques
		var informationsTrollsBT = '#' + systemeTactique + ';' + marqueurTemporel(); // début du bloc d'informations concernant le Système Tactique visité
		for (var i=1;i<listeTrolls.length;i++) {
			// extraction des informations d'une ligne du tableau si les informations ont bien été récupérées par le site des Bricol'Troll
			var donnees = listeTrolls[i].getElementsByTagName('td');
			if ( donnees[8].innerHTML.indexOf('Mot de passe invalide') == -1 ) {
				var reference = donnees[1].innerHTML;
				var nom = donnees[0].firstChild.innerHTML;
				var niveau = donnees[3].innerHTML;
				var race = donnees[2].innerHTML;
				var fatigue = donnees[0].outerHTML.substr(donnees[0].outerHTML.indexOf('<strong>Fatigue actuelle : </strong>'), donnees[0].outerHTML.indexOf('\')" onmouseout="HideInfos()"') - donnees[0].outerHTML.indexOf('<strong>Fatigue actuelle : </strong>')).replace(/<strong>|<\/strong>/g, '').replace(/<br><br>INTANGIBLE/g, '').replace(/<br>/g, '\r');
				var statut = (donnees[0].outerHTML.indexOf('INTANGIBLE') != -1) ? 'intangible' : '';
				var visibilite = donnees[4].innerHTML.split(', ')[2].substr(donnees[4].innerHTML.split(', ')[2].indexOf('title')+7, 9).replace('"', '');
				var PV = donnees[5].innerHTML.substr(0, donnees[5].innerHTML.indexOf('<br>')).replace(' / ', '/');
				var couleurBarrePV = donnees[5].innerHTML.substr(donnees[5].innerHTML.indexOf('color')+7, 7);
				var MAJ = donnees[7].innerHTML.substr(donnees[7].innerHTML.indexOf('MAJ :')+6, 19);
				var PA = donnees[6].innerHTML;
				var DLA = donnees[7].innerHTML.substr(donnees[7].innerHTML.indexOf('DLA :')+6, 19);;
				var X = donnees[4].innerHTML.split(', ')[0];
				var Y = donnees[4].innerHTML.split(', ')[1];
				var	N = donnees[4].innerHTML.split(', ')[2].substr(0, donnees[4].innerHTML.split(', ')[2].indexOf('&nbsp;') != -1 ? donnees[4].innerHTML.split(', ')[2].indexOf('&nbsp;') : donnees[4].innerHTML.split(', ')[2].length);
				// détection de l'anomalie des PV max
				if ( parseInt(PV.split('/')[0]) > parseInt(PV.split('/')[1]) ) {
					// indication de l'anomalie au niveau de la cellule des PV
					donnees[5].style.color = '#990000'; // rouge
					donnees[5].style.fontWeight = 'bold';
					donnees[5].title = 'Anomalie détectée au niveau du nombre de PV max :\r\nVeuillez mettre à jour les Mouches et/ou l\'Equipement porté.';
				}
				// analyse du temps écoulé depuis la dernière mise-à-jour des informations de la ligne et valorisation des variables en conséquence
				var urlIcone = urlIconeAffichageInfo;
				var titreIcone = 'Ces informations sont dépassées, elles datent de plus de ' + dureeInfoTrollsPerimees + ' heure' + ( dureeInfoTrollsPerimees >= 2 ? 's' : '' ) + '.\r\nCliquez pour les mettre à jour.';
				var lienIcone = 'update_info.php?id=' + reference;
				if ( marqueurTemporel() - convertirDateEnMarqueurTemporel(MAJ, ' ', '/') < dureeInfoTrollsRecentes * 3600 ) { // N * 3600 secondes = N heure(s)
					urlIcone = urlIconeInfoRecentes;
					titreIcone = 'Ces informations sont récentes, elles datent de moins de ' + dureeInfoTrollsRecentes + ' heure' + ( dureeInfoTrollsRecentes >= 2 ? 's' : '' ) + '.';
					lienIcone = '';
				}
				else if ( marqueurTemporel() - convertirDateEnMarqueurTemporel(MAJ, ' ', '/') < dureeInfoTrollsAnciennes * 3600 ) { // N * 3600 secondes = N heure(s)
					urlIcone = urlIconeInfoAnciennes;
					titreIcone = 'Ces informations ne sont plus très récentes, elles datent de plus de ' + dureeInfoTrollsRecentes + ' heure' + ( dureeInfoTrollsRecentes >= 2 ? 's' : '' ) + '.\r\nCliquez pour les mettre à jour.';
				}
				else if ( marqueurTemporel() - convertirDateEnMarqueurTemporel(MAJ, ' ', '/') < dureeInfoTrollsPerimees * 3600 ) { // N * 3600 secondes = N heure(s)
					urlIcone = urlIconeInfoPerimees;
					titreIcone = 'Ces informations peuvent être dépassées, elles datent de plus de ' + dureeInfoTrollsAnciennes + ' heure' + ( dureeInfoTrollsAnciennes >= 2 ? 's' : '' ) + '.\r\nCliquez pour les mettre à jour.';
				}
				// ajout de la puce représentant la durée écoulée depuis la dernière mise-à-jour des informations de la ligne
				var unLien = document.createElement( lienIcone != '' ? 'a' : 'span' );
				unLien.href = lienIcone;
				var uneImage = document.createElement('img');
				uneImage.src = urlIcone;
				uneImage.title = titreIcone;
				uneImage.align = 'absmiddle';
				unLien.appendChild(uneImage);
				donnees[8].insertBefore(creerEspacement(2), donnees[8].childNodes[6]);
				donnees[8].insertBefore(unLien, donnees[8].childNodes[6]);
				// concaténation des informations des Trolls
				informationsTrollsBT += '@' + reference + ';' + nom + ';' + statut + ';' + niveau + ';' + race + ';' + fatigue + ';' + systemeTactique + ';' + referenceGroupe + ';' + nomGroupe + ';' + visibilite + ';' + PV + ';' + couleurBarrePV + ';' + MAJ + ';' + PA + ';' + DLA + ';' + X + ';' + Y + ';' + N;
			}
		}
		informationsTrollsBT += '@' + systemeTactique + '/#' // fin du bloc d'informations concernant le Système Tactique visité
		
		// récupération des informations précédemment sauvegardées
		var precedantesInfos = decoderASCII(GM_getValue('informationsTrollsBT'));
		
		// sauvegarde des informations mises à jour dans le fichier prefs.js de Firefox (les informations les plus récentes doivent être en premier)
		GM_setValue('informationsTrollsBT', encoderASCII(informationsTrollsBT + supprimeBlocInfos(precedantesInfos, systemeTactique)));
	}
	catch (e) {
		window.alert('BT_inside_MZ.user.js Bricol\'Trolls Accueil() : ' + e.message);
	}
}

// *** Procédure principale exécutée sur la page de gestion des Gowaps & Tanières du site des Bricol'Trolls ***
if ( window.self.location.toString().indexOf('/gowaps_tanieres.php') != -1 && document.getElementById('content') != null ) {
	try {
		// récupération des informations du Système Tactique
		var systemeTactique = window.self.location.toString().substr(0, window.self.location.toString().indexOf('/gowaps_tanieres.php')).replace('http://trolls.ratibus.net/', '');
		var tableSuivants = document.getElementById('content').getElementsByTagName('table')[0].getElementsByTagName('tr');
		var listeGroupes = document.getElementById('id_g');
		var referenceGroupe = listeGroupes.options[listeGroupes.selectedIndex].value;

		// récupération des informations de chaque Suivant de chaque Troll du Système Tactique
		var informationsSuivantsBT = '#' + systemeTactique + ';' + marqueurTemporel(); // début du bloc d'informations concernant le Système Tactique visité
		for (var i=0;i<tableSuivants.length;i++) {
			// extraction des informations d'une ligne de Troll
			var donnees = tableSuivants[i].getElementsByTagName('em');
			var referenceTroll = donnees[0].innerHTML.substr(donnees[0].innerHTML.indexOf('?id=')+4, donnees[0].innerHTML.indexOf('&amp;id_g=') - (donnees[0].innerHTML.indexOf('?id=')+4));
			var nomTroll = donnees[0].previousSibling.nodeValue.replace('Gowap(s) de ', '').replace(/\u00a0/g, '');
			var MAJ = donnees[0].innerHTML.substr(donnees[0].innerHTML.indexOf('maj : ')+6, 19);
			// analyse du temps écoulé depuis la dernière mise-à-jour des informations des Suivants de ce Troll et valorisation des variables en conséquence
			var urlIcone = urlIconeAffichageInfo;
			var titreIcone = 'Ces informations sont dépassées, elles datent de plus de ' + dureeInfoSuivantsPerimees + ' heure' + ( dureeInfoSuivantsPerimees >= 2 ? 's' : '' ) + '.\r\nCliquez pour les mettre à jour.';
			var lienIcone = 'update_gowaps.php?id=' + referenceTroll + '&id_g=' + referenceGroupe;
			if ( marqueurTemporel() - convertirDateEnMarqueurTemporel(MAJ, ' ', '/') < dureeInfoSuivantsRecentes * 3600 ) { // N * 3600 secondes = N heure(s)
				urlIcone = urlIconeInfoRecentes;
				titreIcone = 'Ces informations sont récentes, elles datent de moins de ' + dureeInfoSuivantsRecentes + ' heure' + ( dureeInfoSuivantsRecentes >= 2 ? 's' : '' ) + '.';
				lienIcone = '';
			}
			else if ( marqueurTemporel() - convertirDateEnMarqueurTemporel(MAJ, ' ', '/') < dureeInfoSuivantsAnciennes * 3600 ) { // N * 3600 secondes = N heure(s)
				urlIcone = urlIconeInfoAnciennes;
				titreIcone = 'Ces informations ne sont plus très récentes, elles datent de plus de ' + dureeInfoSuivantsRecentes + ' heure' + ( dureeInfoSuivantsRecentes >= 2 ? 's' : '' ) + '.\r\nCliquez pour les mettre à jour.';
			}
			else if ( marqueurTemporel() - convertirDateEnMarqueurTemporel(MAJ, ' ', '/') < dureeInfoSuivantsPerimees * 3600 ) { // N * 3600 secondes = N heure(s)
				urlIcone = urlIconeInfoPerimees;
				titreIcone = 'Ces informations peuvent être dépassées, elles datent de plus de ' + dureeInfoSuivantsAnciennes + ' heure' + ( dureeInfoSuivantsAnciennes >= 2 ? 's' : '' ) + '.\r\nCliquez pour les mettre à jour.';
			}
			// ajout de la puce représentant la durée écoulée depuis la dernière mise-à-jour des informations des Suivants de ce Troll
			var unLien = document.createElement( lienIcone != '' ? 'a' : 'span' );
			unLien.href = lienIcone;
			var uneImage = document.createElement('img');
			uneImage.src = urlIcone;
			uneImage.title = titreIcone;
			uneImage.align = 'absmiddle';
			unLien.appendChild(uneImage);
			donnees[0].insertBefore(unLien, donnees[0].lastChild);
			donnees[0].insertBefore(creerEspacement(1), donnees[0].lastChild);
			// passage aux lignes des Suivants de ce Troll
			i++;
			// extraction des informations des Suivants si il y en a
			donnees = tableSuivants[i].getElementsByClassName('gowapEquipementList');
			if ( donnees ) {
				for (var j=0;j<donnees.length;j++) {
					var referenceSuivant = donnees[j].previousSibling.childNodes[1].innerHTML;
					var infos = donnees[j].previousSibling.childNodes[2].nodeValue.substr(donnees[j].previousSibling.childNodes[2].nodeValue.indexOf(')')+3, donnees[j].previousSibling.childNodes[2].nodeValue.length);
					var equipement = '';
					var equipements = donnees[j].innerHTML.split('</li>');
					for (var k=0;k<equipements.length;k++) {
						equipement += equipements[k].replace(/<strong><\/strong>/g, '').replace(/ +\(\D.*\),/g, ',') + '</li>'; 
					}
					equipement = equipement.replace(/\\'/g, '\'').replace(/<\/li><\/li>/g, '</li>').replace(/<li>Vide<\/li>/g, 'Vide');				
					var coordonnees = donnees[j].previousSibling.childNodes[2].nodeValue.substr(donnees[j].previousSibling.childNodes[2].nodeValue.indexOf('(')+1, donnees[j].previousSibling.childNodes[2].nodeValue.indexOf(')') - (donnees[j].previousSibling.childNodes[2].nodeValue.indexOf('(')+1)).split(', ');
					var X = parseInt(coordonnees[0].substr(coordonnees[0].indexOf('= ')+2, coordonnees[0].length));
					var Y = parseInt(coordonnees[1].substr(coordonnees[1].indexOf('= ')+2, coordonnees[1].length));
					var N = parseInt(coordonnees[2].substr(coordonnees[2].indexOf('= ')+2, coordonnees[2].length));
					// concaténation des informations des Suivants
					informationsSuivantsBT += '@' + referenceSuivant + ';' + referenceTroll + ';' + nomTroll + ';' + systemeTactique + ';' + referenceGroupe + ';' + MAJ + ';' + infos + ';' + equipement + ';' + X + ';' + Y + ';' + N; 
				}
			}
		}
		informationsSuivantsBT += '@' + systemeTactique + '/#' // fin du bloc d'informations concernant le Système Tactique visité

		// récupération des informations précédemment sauvegardées
		var precedantesInfos = decoderASCII(GM_getValue('informationsSuivantsBT'));
		
		// sauvegarde des informations mises à jour dans le fichier prefs.js de Firefox (les informations les plus récentes doivent être en premier)
		GM_setValue('informationsSuivantsBT', encoderASCII(informationsSuivantsBT + supprimeBlocInfos(precedantesInfos, systemeTactique)));
	}
	catch (e) {
		window.alert('BT_inside_MZ.user.js Bricol\'Trolls Gowaps() : ' + e.message);
	}
}


// *** Procédure principale exécutée sur la page de Vue de Mountyhall ***
if ( window.self.location.toString().indexOf('/MH_Play/Play_vue.php') != -1 ) {
	try {
		// passage des constantes dans le localStorage
		window.localStorage.BT_inside_MZ_constantes = dureeAffichageInfo + ';' + dureeInfoTrollsRecentes + ';' + dureeInfoTrollsAnciennes + ';' + dureeInfoTrollsPerimees + ';' + dureeInfoSuivantsRecentes + ';' + dureeInfoSuivantsAnciennes + ';' + dureeInfoSuivantsPerimees + ';' + urlIconeAffichageInfo + ';' + urlIconeInfoRecentes + ';' + urlIconeInfoAnciennes + ';' + urlIconeInfoPerimees + ';' + urlIconeVisibilite + ';' + couleurJouable + ';' + couleurNonJouable + ';' + couleurLigneTrolls + ';' + couleurLigneTrollsHorsVue + ';' + couleurLigneSuivantsPerso + ';' + couleurLigneSuivants + ';' + distanceMax;
		
		// suppression des contenus du localStorage pour la page de Vue de MountyHall (pour que MountyZilla n'utilise pas des informations dépassées)
		window.localStorage.removeItem('BT_inside_MZ_infoTrolls');
		window.localStorage.removeItem('BT_inside_MZ_infoSuivants');

		// récupération de la référence du Troll connecté à MountyHall
		var referenceTroll = document.getElementsByName('ai_IdPJ')[0].value;
      
		// récupération de la position du Troll connecté à MountyHall
		var texte = document.evaluate("//li/b/text()[contains(.,'X = ')]", document, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null).singleNodeValue.nodeValue;
		var positionTroll = texte.split('[')[0].replace(/[A-z]| |=|[\n\r]/g, '').split(','); // .split('[')[0] pour éliminer le nom du Pocket Hall

		// récupération des positions des colonnes
		var indexColonnes = {Reference: -1, Nom: -1, Guilde: -1};
		var titresColonnes = document.getElementById('mh_vue_hidden_trolls').getElementsByTagName('thead')[0].getElementsByTagName('th');
		for (var i=0;i<titresColonnes.length;i++) {
			if (titresColonnes[i].innerHTML.indexOf('Réf.') != -1) {
				indexColonnes.Reference = i;
			}
			if (titresColonnes[i].innerHTML.indexOf('Nom') != -1) {
				indexColonnes.Nom = i;
			}
			if (titresColonnes[i].innerHTML.indexOf('Guilde') != -1) {
				indexColonnes.Guilde = i;
			}
		}
		
		// compile si nécessaire les informations des Trolls récupérées depuis les Systèmes Tactiques des Bricol'Trolls auxquels appartient le Troll connecté
		if ( compileInformationsTrollsBT(referenceTroll) ) {
			
			// si la zone d'affichage est présente (c'est-à-dire pas d'effet Oukisont de Fumeux)
			if ( document.getElementById('mh_vue_hidden_trolls') != null ) {
				// récupération des lignes Trolls affichées dans la Vue MountyHall
				var trollsDeMH = document.getElementById('mh_vue_hidden_trolls').getElementsByTagName('tbody')[0].getElementsByTagName('tr');
				// calcul des distances des Trolls
				for (var i=0;i<trollsDesST.length;i++) {
					// si les coordonnées X, Y et N sont volontairement ignorées, alors la distance ne doit pas être calculée
					if ( trollsDesST[i].X == distanceMax ) {
						trollsDesST[i].Distance = distanceMax; // distanceMax pour que le tri triTrollsST et le tri du tableau dans la page Vue MH fonctionnent correctement
					}
					else {
						// sinon, calcul de la distance
						trollsDesST[i].Distance = 0;	
						trollsDesST[i].Distance = Math.max(trollsDesST[i].Distance, Math.abs(positionTroll[0] - trollsDesST[i].X));
						trollsDesST[i].Distance = Math.max(trollsDesST[i].Distance, Math.abs(positionTroll[1] - trollsDesST[i].Y));
						trollsDesST[i].Distance = Math.max(trollsDesST[i].Distance, Math.abs(positionTroll[2] - trollsDesST[i].N));
					}
				}
				// tri des Trolls tel qu'il est fait dans MountyHall (Distance, N, X, Y, Nom)
				trollsDesST.sort(triTrollsST);
				// ajout dans la vue MountyHall des Trolls qui n'y sont pas (les Trolls seront ajoutés dans la Vue MountyHall par ce script avant que MountyZilla n'analyse les données de la Vue et seront donc traités par MountyZilla)
				var trollEstDanslaVue;
//				if (document.getElementById('mh_vue_hidden_trolls').getElementsByTagName('tbody')[0].getElementsByTagName('tr').length == 0) {
//					// si il n'y a aucun Troll visible dans la Vue, alors ajout de la zone contenant normalement des Trolls, dans laquelle seront ajoutées les Trolls du Système Tactique  
//					document.getElementById('mh_vue_hidden_trolls').getElementsByTagName('table')[0].appendChild(document.createElement('tbody'));
//				}
				var zoneLignesTrolls = document.getElementById('mh_vue_hidden_trolls').getElementsByTagName('tbody')[0];
				for (var i=0;i<trollsDesST.length;i++) {
					trollEstDanslaVue = false;
					for (var j=0;j<trollsDeMH.length;j++) {
						if ( trollsDesST[i].Reference == trollsDeMH[j].childNodes[indexColonnes.Reference].innerHTML ) {
							// le Troll a été trouvé dans la Vue
							trollEstDanslaVue = true;
							// ajout du Système Tactique utilisé dans la colonne Guilde si le Troll dans la Vue n'a pas de Guilde
							if ( !trollsDeMH[j].childNodes[indexColonnes.Guilde].innerHTML ) {
								trollsDeMH[j].childNodes[indexColonnes.Guilde].innerHTML = '<A HREF=\'http://trolls.ratibus.net/' + trollsDesST[i].SystemeTactique + '/index.php?id_g=' + trollsDesST[i].ReferenceGroupe + '\' CLASS=\'mh_links\' target="_blank">' + trollsDesST[i].SystemeTactique + ' ' + trollsDesST[i].NomGroupe;
							}							
							// sortie de la boucle car le Troll a été trouvé dans la Vue
							break;
						}					
					}
					// si le Troll n'est pas déjà dans la Vue, alors ajout d'une nouvelle ligne pour ce Troll
					if ( !trollEstDanslaVue ) {
						// modification du titre de la colonne
						document.getElementById('mh_vue_hidden_trolls').getElementsByTagName('thead')[0].getElementsByTagName('th')[indexColonnes.Guilde].innerHTML = '<b>Guilde ou Système Tactique</b>';
						// parcours des lignes de Trolls jusqu'à : 1- la bonne Distance, 2- le bon N, 3- le bon X, 4- le bon Y, 5- le bon Nom
						var ligneCible = null;
						for (var j=1;j<trollsDeMH.length;j++) {
							if ( trollsDesST[i].Distance == distanceMax ) {
								// sortie car la distance est absente et le Troll doit être inséré à la fin de la zone d'affichage des Trolls 
								break;
							}
							// 1- affichage ordonné par Distance croissante 
							if ( trollsDeMH[j].childNodes[0].innerHTML > trollsDesST[i].Distance ) {
								// sauvegarde de la ligne avant laquelle il faudra insérer le Troll non visible 
								ligneCible = trollsDeMH[j];
								// sortie de la boucle puisque la ligne cible a été déterminée
								break;
							}
							else if ( trollsDeMH[j].childNodes[0].innerHTML == trollsDesST[i].Distance ) {
								// 2- puis affichage ordonné par N décroissant
								if ( trollsDeMH[j].lastChild.innerHTML > trollsDesST[i].N ) {
									ligneCible = trollsDeMH[j];
									break;
								}
								else if ( trollsDeMH[j].lastChild.innerHTML == trollsDesST[i].N ) {
									// 3- puis affichage ordonné par X croissant
									if ( trollsDeMH[j].lastChild.previousSibling.previousSibling.innerHTML < trollsDesST[i].X ) {
										ligneCible = trollsDeMH[j];
										break;
									}
									else if ( trollsDeMH[j].lastChild.previousSibling.previousSibling.innerHTML == trollsDesST[i].X ) {
										// 4- puis affichage ordonné par Y croissant
										if ( trollsDeMH[j].lastChild.previousSibling.innerHTML < trollsDesST[i].Y ) {
											ligneCible = trollsDeMH[j];
											break;
										}
										else if ( trollsDeMH[j].lastChild.previousSibling.innerHTML == trollsDesST[i].Y ) {
											// 5- puis affichage ordonné par Nom dans l'ordre alphabétique croissant
											if ( trollsDeMH[j].childNodes[indexColonnes.Nom].firstChild.innerHTML.toUpperCase() > trollsDesST[i].Nom.toUpperCase() ) {
												ligneCible = trollsDeMH[j];
												break;
											}
										}
									}
								}
							}
						}
						if ( ligneCible != null ) {
							// ajout du Troll non visible avant la ligne cible
							zoneLignesTrolls.insertBefore(creerTRdeTroll(trollsDesST[i].Distance, trollsDesST[i].Reference, trollsDesST[i].Nom, trollsDesST[i].Statut, trollsDesST[i].Niveau, trollsDesST[i].Race, trollsDesST[i].Fatigue, trollsDesST[i].SystemeTactique, trollsDesST[i].ReferenceGroupe, trollsDesST[i].NomGroupe, trollsDesST[i].Visibilite, trollsDesST[i].PV, trollsDesST[i].CouleurBarrePV, trollsDesST[i].MAJ, trollsDesST[i].PA, trollsDesST[i].DLA, trollsDesST[i].X, trollsDesST[i].Y, trollsDesST[i].N), ligneCible);
						}
						else {
							// ajout du Troll non visible à la fin de la zone des lignes de Trolls
							zoneLignesTrolls.appendChild(creerTRdeTroll(trollsDesST[i].Distance, trollsDesST[i].Reference, trollsDesST[i].Nom, trollsDesST[i].Statut, trollsDesST[i].Niveau, trollsDesST[i].Race, trollsDesST[i].Fatigue, trollsDesST[i].SystemeTactique, trollsDesST[i].ReferenceGroupe, trollsDesST[i].NomGroupe, trollsDesST[i].Visibilite, trollsDesST[i].PV, trollsDesST[i].CouleurBarrePV, trollsDesST[i].MAJ, trollsDesST[i].PA, trollsDesST[i].DLA, trollsDesST[i].X, trollsDesST[i].Y, trollsDesST[i].N));
						}
					}
				}
			}
			// récupère les informations des Suivants issues des Systèmes Tactiques des Bricol'Trolls et les sauvegarde dans le localStorage du navigateur pour y être ensuite récupérées par le script BT_inside_MZ.js pour MountyZilla et être utilisées dans la page de Vue de MountyHall
			window.localStorage.BT_inside_MZ_infoSuivants = GM_getValue('informationsSuivantsBT');
		}
	}
	catch (e) {
		window.alert('BT_inside_MZ.user.js MountyHall Vue : ' + e.message);
	}
}


// *** vérifie la date de la dernière récupération d'information depuis les Systèmes Tactiques des Bricol'Trolls et extrait les informations des Trolls si nécessaire ***
 function compileInformationsTrollsBT(referenceTroll) {
	try {
		// récupération des informations enregistrées dans le fichiers prefs.js de Firefox
		var informationsTrollsBT = decoderASCII(GM_getValue('informationsTrollsBT'));
		if ( informationsTrollsBT == '' ) { 
			return false;
		}
		// découpage par Système Tactique
		var listeST = informationsTrollsBT.split('/#');
		var suiteTrollsTraites = '';
		trollsDesST.length = 0;
		for (var i=0;i<listeST.length-1;i++) {
			// si la date de dernière mise à jour des informations est trop antérieure à la date du moment, alors on ne tient pas compte de ces informations et elles sont supprimées
			if ( marqueurTemporel() - parseInt(listeST[i].substr(listeST[i].indexOf(';')+1, listeST[i].indexOf('@'))) > dureeAffichageInfo * 3600 ) { // N x 3600 secondes = N heures
				// récupération des informations précédemment sauvegardées
				var precedantesInfos = decoderASCII(GM_getValue('informationsTrollsBT'));
				// sauvegarde des informations mises à jour dans le fichier prefs.js de Firefox
				GM_setValue('informationsTrollsBT', encoderASCII(supprimeBlocInfos(precedantesInfos, listeST[i].substr(listeST[i].indexOf('#')+1, listeST[i].indexOf(';')-1))));
				// de même, suppression des informations des Suivants de ce Système Tactique
				if ( GM_getValue('informationsSuivantsBT') ) {
					precedantesInfos = decoderASCII(GM_getValue('informationsSuivantsBT'));
					GM_setValue('informationsSuivantsBT', encoderASCII(supprimeBlocInfos(precedantesInfos, listeST[i].substr(listeST[i].indexOf('#')+1, listeST[i].indexOf(';')-1))));
				}
			}
			else {
				// si le Troll connecté appartient au Système Tactique traité, il faut tenir compte de ces informations 
				if ( listeST[i].indexOf(referenceTroll) != -1 ) {
					// transfert des informations dans le tableau des Trolls des Systèmes Tactiques : trollsDesST
					var listeTrolls = listeST[i].split('@');
					for (var j=1;j<listeTrolls.length-1;j++) {
						var lesDonnees = listeTrolls[j].split(';');
						// Seuls les Trolls autres que celui connecté et les Trolls dont la date de mise à jour est comprise dans la période d'affichage sont pris en considération
						if ( lesDonnees[0] != referenceTroll && marqueurTemporel() - convertirDateEnMarqueurTemporel(lesDonnees[12], ' ', '/') < dureeAffichageInfo * 3600 ) {
							// si la date de mise à jour des information du site des Bricol'Trolls est trop antérieure à la date du moment, alors il ne faut pas prendre en compte les informations de coordonnées X, Y et N
							if ( marqueurTemporel() - convertirDateEnMarqueurTemporel(lesDonnees[12], ' ', '/') > dureeInfoTrollsPerimees * 3600 ) { // N x 3600 secondes = N heures
								lesDonnees[15] = '9999';
								lesDonnees[16] = '9999';
								lesDonnees[17] = '9999';
							}
							// transfert des informations (si un Troll est présent dans plusieurs Systèmes Tactiques alors seules les informations du dernier Système Tactique visité sont prises en compte : pour cela les informations les plus récentes doivent être en premier dans 'informationsTrollsBT')
							if ( suiteTrollsTraites.indexOf(';' + lesDonnees[0] + ';') == -1 ) {
								trollsDesST.push({Reference: lesDonnees[0], Nom: lesDonnees[1], Statut: lesDonnees[2], Niveau: lesDonnees[3], Race: lesDonnees[4], Fatigue: lesDonnees[5], SystemeTactique: lesDonnees[6], ReferenceGroupe: lesDonnees[7], NomGroupe: lesDonnees[8], Visibilite: lesDonnees[9], PV: lesDonnees[10], CouleurBarrePV: lesDonnees[11], MAJ: lesDonnees[12], PA: lesDonnees[13], DLA: lesDonnees[14], X: lesDonnees[15], Y: lesDonnees[16], N: lesDonnees[17]});
								// ajout du Troll dans la suite des Trolls déjà traités
								suiteTrollsTraites += ';' + lesDonnees[0] + ';';
							}
						}
					}
				}
			}
		}
		// transfert des informations dans le localStorage du navigateur pour y être ensuite récupérées par le script BT_inside_MZ.js pour MountyZilla et être utilisées dans la page de Vue de MountyHall
		window.localStorage.BT_inside_MZ_infoTrolls = GM_getValue('informationsTrollsBT');

		return true;
	}
	catch (e) {
		window.alert('BT_inside_MZ.user.js compileInformationsTrollsBT() : ' + e.message);
	}		
 }
 

// *** retourne un marqueur temporel correspondant à l'instant présent, en secondes depuis le 01-01-1970 ***
 function marqueurTemporel() {
	try {
		// marqueur temporel getTime() en millisecondes, converti en secondes et arrondi
		return Math.round(new Date().getTime() / 1000);
	}
	catch (e) {
		window.alert('BT_inside_MZ.user.js marqueurTemporel() : ' + e.message);
	}		
 }
 
 
// *** retourne la date passée en paramètre (format 'DD/MM/YYYY HH:mm:ss') convertie en marqueur temporel, en secondes depuis le 01-01-1970 ***
 function convertirDateEnMarqueurTemporel(dateAConvertir, separateur1, separateur2) {
	try {
		// le separateur1 délimite la date et l'heure. Le separateur2 délimite le jour, le mois et l'année qui sont inversés
		return new Date( dateAConvertir.split(separateur1)[0].split(separateur2).reverse().join('-') + 'T' + dateAConvertir.split(separateur1)[1] ).getTime() / 1000;
	}
	catch (e) {
		window.alert('BT_inside_MZ.user.js convertirDateEnMarqueurTemporel() : ' + e.message);
	}		
 }
 
 
 // *** fonction de tri des Trolls des Systèmes Tactiques : tri dans l'ordre de MountyHall ( 1- distance croissante, 2- N décroissant, 3- X croissant, 4- Y croissant, 5- Nom alphabétique croissant ) ***
function triTrollsST(a, b){
	try {
		// si les distances sont présentes il faut tenir compte des distances et des coordonnées X, Y et N
		if ( a.Distance != distanceMax && b.Distance != distanceMax ) {
			// 1- distance
			if ( a.Distance != b.Distance ) {
				// tri croissant
				return a.Distance - b.Distance;
			}

			// 2- N
			if ( a.N != b.N ) {
				// tri décroissant 
				return b.N - a.N;
			}
			
			// 3- X
			if ( a.X != b.X ) {
				// tri croissant 
				return a.X - b.X;
			}
			
			// 4- Y
			if ( a.Y != b.Y ) {
				// tri croissant 
				return a.Y - b.Y;
			}
		}
		// sinon, les Trolls dont la distance est absente doivent être après les Trolls dont la distance est présente
		else if ( a.Distance != distanceMax && b.Distance == distanceMax ) {
			return -1;
		}
		else if ( a.Distance == distanceMax && b.Distance != distanceMax ) {
			return 1;
		}
		
		// 5- Nom
		if ( a.Nom.toUpperCase() < b.Nom.toUpperCase() ) {
			// tri alphabétique croissant 
			return -1;
		}
		else if ( a.Nom.toUpperCase() > b.Nom.toUpperCase() ) {
			// tri alphabétique croissant 
			return 1;
		}
		else {
			// égalité
			return 0;
		}
	}
	catch (e) {
		window.alert('BT_inside_MZ.user.js triTrollsST() : ' + e.message);
	}
}
 
 // *** crée la structure <TR></TR> d'un Troll avec son contenu ***
 function creerTRdeTroll(distance, reference, nom, statut, niveau, race, fatigue, systemeTactique, referenceGroupe, nomGroupe, visibilite, PV, couleurBarrePV, MAJ, PA, DLA, X, Y, N) {
	try {
		// création à partir des valeurs passées en paramètres
		var unTR = document.createElement('tr');
		unTR.setAttribute('class', 'mh_tdpage');
		unTR.innerHTML = '<TD>' + distance;
		if (document.getElementById('mh_vue_hidden_trolls').getElementsByTagName('thead')[0].getElementsByTagName('th')[1].innerHTML.indexOf('Actions') != -1) {
			unTR.innerHTML += '</TD><TD>'; // Actions
		}
		unTR.innerHTML += '</TD><TD>' + reference;
		unTR.innerHTML += '</TD><TD><A HREF="javascript:EPV(' + reference + ')" CLASS=\'mh_trolls_' + (statut == 'intangible' ? 0 : 1) + '\'>' + nom;
		unTR.innerHTML += '</TD><TD><A HREF=\'http://trolls.ratibus.net/' + systemeTactique + '/index.php?id_g=' + referenceGroupe + '\' CLASS=\'mh_links\' target="_blank">' + systemeTactique + ' ' + nomGroupe;
		unTR.innerHTML += '</A></TD><TD align="center">' + niveau;
		unTR.innerHTML += '</TD><TD>' + race;
		unTR.innerHTML += '</A></TD><TD align="center">' + X;
		unTR.innerHTML += '</TD><TD align="center">' + Y;
		unTR.innerHTML += '</TD><TD align="center">' + N + '</TD>';
		// marquage du TR comme étant inséré par le script BT_inside (ce marquage est nécessaire à la compatibilité avec le script DEZenfumage.js)
		unTR.firstChild.setAttribute('origine', 'BT_inside');
		// retour de la structure créée
		return unTR;
	}
	catch (e) {
		window.alert('BT_inside_MZ.user.js creerTRdeTroll() : ' + e.message);
	}		
 }

 
 // *** supprime dans le texte les caractères du bloc déterminé par la balise, balises de début et de fin incluses ***
function supprimeBlocInfos(texte, balise) {
	try {
		// si aucun texte à traiter, alors on retourne une chaîne vide
		if ( !texte ) return '';
	
		// construction des balises de début et de fin
		var baliseDebut = '#' + balise;
		var baliseFin = balise + '/#';
		
		// si la balise de début n'est pas présente dans le texte, alors on retourne le texte tel quel
		if ( texte.indexOf(baliseDebut) == -1 ) return texte
		
		// suppression dans le texte, balises incluses
		var texteModifie = texte.substr(0, texte.indexOf(baliseDebut));
		texteModifie += texte.substr(texte.indexOf(baliseFin) + baliseFin.length, texte.length);
		return texteModifie;
	}
	catch (e) {
		window.alert('BT_inside_MZ.user.js supprimeBlocInfos() : ' + e.message);
	}	
}

// *** Crée un espacement (si un paramètre cssFloat est fourni alors il est utilisé) ***
function creerEspacement(nombreEspaces, cssFloat) {
	var unEspacement = document.createElement('span');
	for (var i=0;i<nombreEspaces;i++) {
		unEspacement.innerHTML += '&nbsp;';
	}
	if (cssFloat) {
		unEspacement.style.cssFloat = cssFloat; // 'left' = sur la même ligne, à la suite; 'right' = sur la même ligne, collé à droite
	}
	return unEspacement;
}

// *** encode un texte sous forme d'une suite de code ASCII, juste pour éviter de pouvoir lire directement et trop facilement les données conservées dans le navigateur ***
function encoderASCII(texte) {
	// si aucun texte à traiter, alors on retourne une chaîne vide
	if ( !texte ) return '';
	
	// chaque caractère du texte passé en paramètre est remplacé par son code ASCII
	var texteEncode = '';
	for (var i=0;i<texte.length;i++) {
		texteEncode += texte.charCodeAt(i) + '|';
	}
	return texteEncode.replace(/\|0\|/g, '|');
}

// *** décode une suite de code ASCII en texte ***
function decoderASCII(texteEncode) {
	// si aucun texte à traiter, alors on retourne une chaîne vide
	if ( !texteEncode ) return '';

	// chaque code ASCII du texte passé en paramètre est remplacé par le caractère correspondant
	var texte = '';
	var caracteres = texteEncode.replace(/\|0\|/g, '|').split('|');
	for (var i=0;i<caracteres.length;i++) {
		texte += String.fromCharCode(caracteres[i]);
	}
	return texte;
}